Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
vanduynguyen

Sửa lisp theo yêu cầu

Các bài được khuyến nghị

Chào các bạn !

Hiện tại mình có lisp nối các đoạn line , polyline thành một đoạn polyline , nhưng có vài trường hợp nó không thể nối được. Bây giờ các bạn giúp mình sửa lisp để những trường hợp đó nó có thể nối được .

Những trường hợp sau nó không nối được .

- Các đoạn line hay polyline bị chồng mí

- Các đoạn line hay polyline bị hở 

http://www.cadviet.com/upfiles/3/115743_lisp_yeu_cau_2.rar

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Chào các bạn !

Hiện tại mình có lisp nối các đoạn line , polyline thành một đoạn polyline , nhưng có vài trường hợp nó không thể nối được. Bây giờ các bạn giúp mình sửa lisp để những trường hợp đó nó có thể nối được .

Những trường hợp sau nó không nối được .

- Các đoạn line hay polyline bị chồng mí

- Các đoạn line hay polyline bị hở 

http://www.cadviet.com/upfiles/3/115743_lisp_yeu_cau_2.rar

Hề hề hề,

Sửa cái lisp của bạn theo mình là không cần thiết bởi lisp này sử dụng lệnh Pedit vốn là lệnh của CAD nên phải tuân thủ các quy định của nó.

Mình gửi bạn cái lisp khác dùng để sửa các đường line, polyline chồng mí nhau hay hở cách nhau một khoảng không quá lớn (tức là khoảng cách chồng mí hay hở giữa các điểm mút của chùng không lớn hơn 1) thành các đường nối tiếp nhau theo đúng yêu cầu của lệnh pedit.

Bạn hãy thử dùng nó sửa các đường line và polyline của bạn rồi sau đó hãy sử dụng lisp nối pline coi có ngon lành không hè.

Vì viết nháp nên nó chưa thật hoàn thiện song hy vọng đúng ý bạn cần, Nếu được mình sẽ hoàn chỉnh thêm sau.

http://www.cadviet.com/upfiles/3/5194_modifypolyline.lsp

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

chào bạn thực ra cái này rất phức tạp.. bởi không chỉ 2 trường hợp mà bạn đã nêu trên.. mà còn rất nhiều trường hợp mà các cao thủ trên diễn đàn cũng thấy khó khăn... đây là đoạn mã lisp có thể giải quyết 1 phần nào yêu cầu của bạn viết bởi tonijen.. cái này có 1 cái hay đó là ví dụ khoảng cách giữa các đối tượng xa nó cũng nối được bằng cách bạn nhập khoảng cách trên bàn phím.. nếu các đối tượng chồng lên nhau cũng vậy... tới rất vui khi được chia sẻ cùng anh em... để dễn dàn cadviet thật sự là nơi giao lưu học hỏi....

sau đây là đoạn mã lệnh là NB

 

(defun c:nb () (c:pljoinfuzz))
(defun c:pljoinfuzz (/ ss1 entLine objType oldcmdecho oldpeditaccept fuzz okObjects)
  (setq oldcmdecho (getvar "cmdecho"))
  (setq oldpeditaccept (getvar "PEDITACCEPT"))
  (setvar "cmdecho" 0)
  (setq A2k4 (>= (substr (getvar "ACADVER") 1 2) "16"))
  (if A2k4 (setvar "PEDITACCEPT" 0))
  (setq okObjects '((0 . "LINE,ARC,POLYLINE,LWPOLYLINE")))
  (princ "\nSelect object to join: ")
  (setq ss1 (ssget okObjects))
  (setq fuzz (getdist "\nFuzz distance <0>: "))
  (if (= fuzz nil) (setq fuzz 0))
  (if (/= ss1 nil)
   (progn
 (setq objType (cdr (assoc 0 (entget (setq entLine (ssname ss1 0))))))
 (if (= (sslength ss1) 1) (setq ss1 (ssget "X" okObjects)))
 (if (member objType '("LINE" "ARC"))
   (command "_.pedit" "_M" ss1 "" "_Y" "_J" "_J" "_B" fuzz "")
   (command "_.pedit" "_M" ss1 "" "_J" "_J" "_B" fuzz ""))))
  (setvar "cmdecho" oldcmdecho)
  (if A2k4 (setvar "PEDITACCEPT" oldpeditaccept))
  (princ))
 

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

chào bạn thực ra cái này rất phức tạp.. bởi không chỉ 2 trường hợp mà bạn đã nêu trên.. mà còn rất nhiều trường hợp mà các cao thủ trên diễn đàn cũng thấy khó khăn... đây là đoạn mã lisp có thể giải quyết 1 phần nào yêu cầu của bạn viết bởi tonijen.. cái này có 1 cái hay đó là ví dụ khoảng cách giữa các đối tượng xa nó cũng nối được bằng cách bạn nhập khoảng cách trên bàn phím.. nếu các đối tượng chồng lên nhau cũng vậy... tới rất vui khi được chia sẻ cùng anh em... để dễn dàn cadviet thật sự là nơi giao lưu học hỏi....

sau đây là đoạn mã lệnh là NB

 

(defun c:nb () (c:pljoinfuzz))

(defun c:pljoinfuzz (/ ss1 entLine objType oldcmdecho oldpeditaccept fuzz okObjects)

  (setq oldcmdecho (getvar "cmdecho"))

  (setq oldpeditaccept (getvar "PEDITACCEPT"))

  (setvar "cmdecho" 0)

  (setq A2k4 (>= (substr (getvar "ACADVER") 1 2) "16"))

  (if A2k4 (setvar "PEDITACCEPT" 0))

  (setq okObjects '((0 . "LINE,ARC,POLYLINE,LWPOLYLINE")))

  (princ "\nSelect object to join: ")

  (setq ss1 (ssget okObjects))

  (setq fuzz (getdist "\nFuzz distance <0>: "))

  (if (= fuzz nil) (setq fuzz 0))

  (if (/= ss1 nil)

   (progn

 (setq objType (cdr (assoc 0 (entget (setq entLine (ssname ss1 0))))))

 (if (= (sslength ss1) 1) (setq ss1 (ssget "X" okObjects)))

 (if (member objType '("LINE" "ARC"))

   (command "_.pedit" "_M" ss1 "" "_Y" "_J" "_J" "_B" fuzz "")

   (command "_.pedit" "_M" ss1 "" "_J" "_J" "_B" fuzz ""))))

  (setvar "cmdecho" oldcmdecho)

  (if A2k4 (setvar "PEDITACCEPT" oldpeditaccept))

  (princ))

 

Hề hề hề,

Cám ơn NguyenBD1, nhờ bạn mình hiểu thêm về một cách dùng khác của lệnh pedit.

Như vầy có nhẽ cái lisp nối polyline của chủ thớt chả cần dùng đến nữa rồi.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×